<?php

class Jnorton_AutoRelateGuest_Model_Observer
{
	public function relateGuestOrders($observer) {

		$event = $observer->getEvent();
		$customer = $event->getCustomer();
		$customer_id = $customer->getId();
		$email = $customer->getEmail();

		//generate query
		$orders = Mage::getModel('sales/order')->getCollection();
		$orders->addFieldToFilter('customer_email', $email);
		$orders->addFieldToFilter('customer_id', array('null' => true));
		$orders->getSelect();
		//return if no results
		if($orders->count() === 0){
			//Mage::log('No results');
			return;
		}
		//loop over order colection and update customer and order status
		foreach ($orders as $order) {
			/** @var Mage_Sales_Model_Order $order */
			// Give some feedback about the process
			//Mage::log('Trying to link order ('.$order->getIncrementId().') to customer ('.$order->getCustomerEmail().')... ');

			try {
				// Change the order to being linked to a customer record
				$order->setCustomerId($customer_id);
				$order->setCustomerIsGuest(0);
				$order->setCustomerGroupId($customer->getGroupId());

				// Add a comment on the order to record that the order was linked to a customer
				$order->addStatusHistoryComment('Automatically linking order to customer by email address');

				// Save changes
				$order->save();

				// Give some feedback about the process
				//Mage::log(__METHOD__ . '() Updated order: '.$order->getIncrementId());

			} catch (Exception $e) {
				// Give some feedback about the process
				Mage::log(__METHOD__ . '() Failed! '. $e->getMessage());
			}
		}
	}

	public function relateGuestOrdersOPC($observer) {

		$orderIds = $observer->getEvent()->getOrderIds();

		if (!is_array($orderIds) || (!array_key_exists(0, $orderIds))) {
			return;
		}

		$order = Mage::getModel('sales/order')->load($orderIds[0]);

		if (!$order->getId()) {
			return;
		}

		if (!$order->getCustomerId()) {
			return;
		}

		$customer = Mage::getModel('customer/customer')->load($order->getCustomerId());

		if (!$customer->getId()) {
			return;
		}

		$customer_id = $customer->getId();
		$email = $customer->getEmail();

		//generate query
		$orders = Mage::getModel('sales/order')->getCollection();
		$orders->addFieldToFilter('customer_email', $email);
		$orders->addFieldToFilter('customer_id', array('null' => true));
		$orders->getSelect();
		//return if no results
		if($orders->count() === 0){
			//Mage::log('No results');
			return;
		}
		//loop over order colection and update customer and order status
		foreach ($orders as $order) {
			/** @var Mage_Sales_Model_Order $order */
			// Give some feedback about the process
			//Mage::log('Trying to link order ('.$order->getIncrementId().') to customer ('.$order->getCustomerEmail().')... ');

			try {
				// Change the order to being linked to a customer record
				$order->setCustomerId($customer_id);
				$order->setCustomerIsGuest(0);
				$order->setCustomerGroupId($customer->getGroupId());

				// Add a comment on the order to record that the order was linked to a customer
				$order->addStatusHistoryComment('Automatically linking order to customer by email address');

				// Save changes
				$order->save();

				// Give some feedback about the process
				//Mage::log(__METHOD__ . '() Updated order: '.$order->getIncrementId());

			} catch (Exception $e) {
				// Give some feedback about the process
				Mage::log(__METHOD__ . '() Failed! '. $e->getMessage());
			}
		}
	}


}

?>